package concurrency.week03;

public class IncrementTest {

	public static void main(String[] args) {
		Counter c = new Counter();
		Thread th1 = new Thread(new TestRun(c));
		Thread th2 = new Thread(new TestRun(c));
		th1.start();
		th2.start();

		try {
			th1.join();
			th2.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		System.out.println("Result value " + c.getValue());
	}

}

class Counter {

	private int value = 0;

	void increment() {
		//synchronized (this) {
			value++;
		//}
	}

	int getValue() {
		return value;
	}

}

class TestRun implements Runnable {

	private static int ROUND = 1000;
	private Counter counter;

	TestRun(Counter c) {
		counter = c;
	}

	@Override
	public void run() {
		for (int i = 0; i < ROUND; i++) {
			counter.increment();
		}
		System.out.println("Added " + ROUND);
	}

}
